<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>FARMWISE IOT PLATFORM</title>
    <style>
        .container2 {
            display: flex;
            flex-direction: row;
        }
        .imageContainer {
            height: 250px;
            width: 350px;
        }
    </style>
</head>
<body>
    <main>
        <!-- Add a container for camera frames -->
        <div id="cameraFrames" class="container2"></div>
    </main>

    <script>
        // Function to create or update a camera div based on camera ID
        function createOrUpdateCameraDiv(cameraId) {
            // Get or create the camera div element
            let cameraDiv = document.getElementById(cameraId);
            if (!cameraDiv) {
                // If the div does not exist, create it
                cameraDiv = document.createElement('div');
                cameraDiv.id = cameraId;
                cameraDiv.classList.add('imageContainer');

                // Create an image element for the camera preview
                const imagePreview = document.createElement('img');
                imagePreview.src = ''; // Leave the src attribute empty for now
                imagePreview.alt = `${cameraId} Preview`;
                imagePreview.classList.add('imagePreview');

                // Append the image element to the camera div
                cameraDiv.appendChild(imagePreview);

                // Append the camera div to the container
                const cameraFrames = document.getElementById('cameraFrames');
                cameraFrames.appendChild(cameraDiv);
            }

            return cameraDiv;
        }

        const socket = new WebSocket('ws://localhost:4000'); // Adjust the WebSocket URL accordingly
        socket.binaryType = 'arraybuffer'; // Set binary data type

        // Initialize a queue for each camera
        const cameraQueues = {};

        socket.addEventListener('open', (event) => {
            console.log('WebSocket connection opened.');
        });

        socket.addEventListener('message', (event) => {
            console.log("WebSocket message received:", event);

            // Extract the camera ID and frame data from the event data
            const data = JSON.parse(event.data);
            const cameraId = data.camera_id;
            const frameData = data.frame_data;

            // Get or create the camera div based on the extracted camera ID
            const cameraDiv = createOrUpdateCameraDiv(cameraId);

            // Get the image element for this camera div
            const imagePreview = cameraDiv.querySelector('.imagePreview');

            // Set the base64-encoded frame data as the image source
            imagePreview.src = 'data:image/jpeg;base64,' + frameData;

            // Set the alt attribute for accessibility
            imagePreview.alt = `${cameraId} Preview`;

            // Schedule the next image to be displayed (if available)
            if (!cameraQueues[cameraId]) {
                cameraQueues[cameraId] = [];
            }
            cameraQueues[cameraId].push(frameData);

            // If the queue has more than one item, display the next image
            if (cameraQueues[cameraId].length === 1) {
                displayNextImage(cameraId);
            }
        });

        // Function to display the next image in the queue
        function displayNextImage(cameraId) {
            const cameraDiv = document.getElementById(cameraId);
            const imagePreview = cameraDiv.querySelector('.imagePreview');
            const frameData = cameraQueues[cameraId][0]; // Get the first item from the queue

            // Set the base64-encoded image data as the image source
            imagePreview.src = 'data:image/jpeg;base64,' + frameData;

            // Set the alt attribute for accessibility
            imagePreview.alt = `${cameraId} Preview`;

            // Remove the displayed image from the queue
            cameraQueues[cameraId].shift();

            // Schedule the next image to be displayed (if available)
            if (cameraQueues[cameraId].length > 0) {
                setTimeout(() => {
                    displayNextImage(cameraId);
                }, 100); // Display the next image after 100 milliseconds
            }
        }

        socket.addEventListener('close', (event) => {
            console.log('WebSocket connection closed.');
        });

        socket.addEventListener('error', (event) => {
            console.error('WebSocket error:', event);
        });
    </script>
</body>
</html>
